/** 
 *  Sample program for Hyper Operating System V4 Advance
 *
 * @file  ostimer.c
 * @brief OS
 *
 * @version $Id: ostimer.c,v 1.1.1.1 2006/08/16 16:27:04 ryuz Exp $
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include "kernel.h"
#include "ostimer.h"
#include "regs_sh7144.h"


#define INHNO_OSTIMER		144		/* ߥϥɥֹ */
#define PERIPHERAL_CLOCK	(24000000UL)	/* ڥե륯å(24MHz) */

/* OSѥ޽롼 */
void OsTimer_Initialize(VP_INT exinf)
{
	/* ư */
	*REG_STANDBY_MSTCR2 &= 0xefff;
	*REG_CMT_CMSTR  &= 0xfffe;								/* ư */
	*REG_CMT0_CMCNT  = 0x0000;								/* 󥿥ꥢ */
	*REG_CMT0_CMCOR  = (PERIPHERAL_CLOCK / 128) / 1000;	/* 1ms */
	*REG_CMT0_CMCSR  = 0x0042;	/* 128ʬ */
	*REG_CMT_CMSTR  |= 0x0001;	/* ư} */
	
	/* ߵ */
	*REG_INTC_IPRG = ((*REG_INTC_IPRG & 0xff0f) | 0x0010);
}


/* ޳ߥϥɥ */
void OsTimer_IrqHandler(void)
{
	*REG_CMT0_CMCSR &= 0xff7f;
	
	isig_tim();
}


/* end of file */
